# AppendGrid

**AppendGrid** allow you to input structured data row by row such like filling spreadsheets. It allows you to add/remove/insert/delete row in the grid. The generated input/select/textarea controls are well named for submitting to server side applications such as ASP.NET/PHP/JSP. Multiple options and callback events are available to fit different situations.


## About verisons
You may find that the project name on GitHub is still "jquery.appendGrid". It is just a historical reason that [version 1](../../tree/v1-dev) required jQuery but it is not required in [version 2](../../tree/v2-dev) anymore. In order to keep GitHub project URL so the repository name was not changed.

The new code is rewritten by using ES6. It will compatible with modern web frameworks such as [Bootstrap](https://getbootstrap.com/) and [Bulma](https://bulma.io/) natively.


## Prerequisite
- Nope, just need a modern web browser that can run JavaScript!


## Demo
Lots of demo cases are available on [Demo section](https://appendgrid.bsite.net/Demo) of **AppendGrid** website.


## Documentation
The full list of options / methods / callback events are available on the [Documentation section](https://appendgrid.bsite.net/Documentation) of **AppendGrid** website.


## Instructions
- Execute command `npm install` to install development dependencies
- Execute command `npm run start` for running development server and preview
- Execute command `npm run build` for creating distribution files


## Others
- Project structure is based on [js-plugin-starter](https://github.com/thatisuday/js-plugin-starter)
- The project website was hosted by AppHarbor but it is [closed on Dec 2022](https://twitter.com/appharbor/status/1590544012481826816) and now it is moved to new hosting provider [FreeASPHosting.net](http://freeasphosting.net/) with as [new project website URL](https://appendgrid.bsite.net)

## License
Licensed under the [MIT](http://www.opensource.org/licenses/mit-license.php) license.